## kamailio 5.6.3

=== src/Makefile ===
# Kamailio makefile
#
# WARNING: requires gmake (GNU Make)
#  Arch supported: Linux, FreeBSD, SunOS (tested on Solaris 8), OpenBSD (3.2),
#  NetBSD (1.6), OS/X
#

# check make version
# everything works with 3.80, except evals inside ifeq/endif
# (see https://savannah.gnu.org/bugs/index.php?func=detailitem&item_id=1516).
# recommended 3.81
req_ver=3.81
# the check below works for version number of the type x.yy or x.yy.z*
# (from the GNU Make Cookbook)
ifeq (,$(filter $(req_ver),$(firstword $(sort $(MAKE_VERSION) $(req_ver)))))
$(error make version $(MAKE_VERSION) not supported, use at least $(req_ver))
endif


auto_gen=core/lex.yy.c core/cfg.tab.c #lexx, yacc etc
auto_gen_others=core/cfg.tab.h # auto generated, non-c
auto_gen_keep=core/autover.h # auto generated, should be included in archives

COREPATH=.
#include  source related defs
include Makefile.sources
#include special targets lists
include Makefile.targets

# whether or not the entire build process should fail if building a module or
#  a utility fails
err_fail?=1

# whether or not to install $(MAIN_NAME).cfg or just $(MAIN_NAME).cfg.default
# ($(MAIN_NAME).cfg will never be overwritten by make install, this is usefull
#  when creating packages)
skip_cfg_install?=

#extra modules to exclude
skip_modules?=

# see Makefile.dirs for the directories used for the modules
include Makefile.dirs

# Set document format
# Alternatives are txt, html, xhtml, and pdf (see Makefile.doc)
doc_format?=html

# don't force modules.lst generation if the makefile goals do not
# require it (but if present use it)
ifeq (,$(strip $(filter-out $(clean_targets) $(aux_targets),$(MAKECMDGOALS))))
ifneq (,$(strip $(wildcard modules.lst)))
-include modules.lst
endif
else
include modules.lst
endif # ifneq (,$(strip $(filter-out ...,$(MAKECMDGOALS))))

#if called with group_include, ignore the modules from modules.lst
ifneq ($(group_include),)
	include_modules=
	exclude_modules=
	modules_configured:=0
endif

# get the groups of modules to compile
include Makefile.groups

# - automatically build the list of excluded modules
# if not set on the cmd. line, env or in the modules.lst (cfg_group_include)
# exclude the below modules.
ifneq ($(group_include)$(cfg_group_include),)
	# For group_include, default all modules are excluded except those in
	# include_modules
	exclude_modules?=
else
	# Old defaults for backwards compatibility
	# excluded because they depend on external libraries
ifeq ($(origin exclude_modules), undefined)
	exclude_modules:= $(sort \
				$(filter-out $(module_group_default), $(mod_list_all)))
endif
endif

# always add skip_modules list - it is done now in modules.lst (dcm)
# override exclude_modules+= $(skip_modules)

# Test for the groups and add to include_modules
ifneq (,$(group_include))
$(eval override include_modules+= $(foreach grp, $(group_include), \
										$(module_group_$(grp)) ))
endif

ALLDEP=config.mak Makefile Makefile.dirs Makefile.sources Makefile.rules

#include general defs (like CC, CFLAGS  a.s.o)
# hack to force makefile.defs re-inclusion (needed when make calls itself with
# other options -- e.g. make bin)
#makefile_defs=0
#C_DEFS:=


# try saved cfg, unless we are in the process of building it or if we're doing
# a clean
ifeq (,$(strip \
	$(filter config.mak config cfg cfg-defs $(clean_targets),$(MAKECMDGOALS))))
include config.mak
ifeq ($(makefile_defs),1)
ifeq ($(quiet),verbose)
$(info config.mak loaded)
endif # verbose
export makefile_defs
# config_make valid & used
config_mak=1
ifeq ($(MAIN_NAME),)
$(error "bad config.mak, try re-running make cfg")
endif
endif
else # config.mak doesn't need to be used
ifneq (,$(filter cfg config cfg-defs,$(word 1,$(MAKECMDGOALS))))
# needed here to avoid starting a config submake 
# (e.g. rm -f config.mak; make config.mak), which would either require 
# double Makefile.defs defines execution (suboptimal), would loose
# $(value ...) expansion or would cause some warning (if Makefile.defs exec. 
# is skipped in the "main" makefile invocation).
$(shell rm -rf config.mak)
config_mak=0
makefile_defs=0
exported_vars=0
else
# config.mak not strictly needed, but try to load it if exists for $(Q)
config_mak=skip
-include config.mak
export makefile_defs
endif
endif


main_makefile=1
include Makefile.defs

static_modules_path=$(addprefix modules/, $(static_modules))
extra_sources=$(wildcard $(addsuffix /*.c, $(static_modules_path)))
extra_objs=$(extra_sources:.c=.o)

static_defs:= $(foreach  mod, $(static_modules), \
		-DSTATIC_$(shell echo $(mod) | tr [:lower:] [:upper:]) )

override extra_defs+=$(static_defs) $(EXTRA_DEFS)
export extra_defs

# Historically, the resultant set of modules is: modules/* - exclude_modules +
# include_modules
# When group_include is used, we want: include_modules (based on group_include)
# - exclude_modules

ifneq ($(modules_configured),1) 
#modules_all=$(filter-out modules/CVS,$(wildcard modules/*))

# create modules*_all vars
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_all=$$(filter-out $(mods)/CVS,$$(wildcard $(mods)/*))))
#debugging
#$(foreach mods,$(modules_dirs),$(info "$(mods)_all=$($(mods)_all)"))

ifneq ($(group_include),)
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)=$$(filter-out $$(addprefix $(mods)/, \
			$$(exclude_modules) $$(static_modules)), \
			$$(addprefix $(mods)/, $$(include_modules) )) ))
else	
	# Standard, old resultant set
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_noinc=$$(filter-out $$(addprefix $(mods)/, \
			$$(exclude_modules) $$(static_modules)), $$($(mods)_all)) \
))
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)=$$(filter-out $$(modules_noinc), \
			$$(addprefix $(mods)/, $$(include_modules) )) $$($(mods)_noinc) \
))
endif # ifneq($(group_include),)
endif # ifneq($(modules_configured),1)

$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_names=$$(shell echo $$($(mods))| \
				sed -e "s/$(mods)"'\/\([^/ ]*\)\/*/\1.so/g' ) \
))
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_basenames:=$$(shell echo $$($(mods))| \
				sed -e "s/$(mods)"'\/\([^/ ]*\)\/*/\1/g' ) \
))

# all modules from all the $(modules_dirs)
all_modules_lst=$(foreach mods,$(modules_dirs), $($(mods)_all))

# compile modules list (all the compiled mods from  $(modules_dirs))
cmodules=$(foreach mods,$(modules_dirs), $($(mods)))

#modules_names=$(patsubst modules/%, %.so, $(modules))
#modules_full_path=$(join  $(modules), $(addprefix /, $(modules_names)))



# list of utils directories that should be compiled by make utils
C_COMPILE_UTILS= # kamcmd is now installed by ctl
# list of binaries that should be installed alongside
# (they should be created after make utils, see C_COMPILE_UTILS)
C_INSTALL_BIN=	# kamcmd is now installed by ctl

# which utils know to install themselves and should be installed
# along the core (list of utils directories)
ifeq ($(FLAVOUR),kamailio)
C_INSTALL_UTILS= ../utils/kamctl
else
C_INSTALL_UTILS=
endif
# list of scripts that should be installed along the core 
# (here a script is something that doesn't have a Makefile)
C_INSTALL_SCRIPTS=
# list of extra configs that should be installed along the core
# Note: all the paths of the form /usr/*lib/$(CFG_NAME)/<module_dir>
# will be updated to the directory where the modules will be installed.
C_INSTALL_CFGS=
# list of files that should be installed in the arch-independent 
# directory (by default /usr/local/share/$(MAIN_NAME)))
C_INSTALL_SHARE=




NAME=$(MAIN_NAME)

tar_name=$(NAME)-$(RELEASE)_src

tar_extra_args+=$(addprefix --exclude=$(notdir $(CURDIR))/, \
					$(auto_gen) $(auto_gen_others))
ifeq ($(CORE_TLS), 1)
	tar_extra_args+=
else
	tar_extra_args+=--exclude=$(notdir $(CURDIR))/tls/* 
endif

ifneq ($(nodeb),)
	tar_extra_args+=--exclude=$(notdir $(CURDIR))/debian 
	tar_name:=$(tar_name)_nodeb
endif

# sanity checks
ifneq ($(TLS),)
        $(warning "make TLS option is obsoleted, try TLS_HOOKS or CORE_TLS")
endif

# include the common rules
include Makefile.rules

#extra targets

$(NAME): $(extra_objs) # static_modules

core/lex.yy.c: core/cfg.lex core/cfg.tab.h $(ALLDEP)
	$(LEX) -o core/lex.yy.c $<

core/cfg.tab.c core/cfg.tab.h: core/cfg.y  $(ALLDEP)
	$(YACC) $(YACC_FLAGS) $<

nullstring=
space=$(nullstring) $(nullstring)

modules_search_path=$(subst $(space),:,$(strip\
						$(foreach m,$(modules_dirs),$($(m)_target))))
		#				$(addprefix $(modules_target),$(modules_dirs))))

# special depends for main.o
main.o: DEFS+=-DMODS_DIR='"$(modules_search_path)"'


#special depends for ver.c
core/ver.d core/ver.o: core/autover.h

include Makefile.shared

ifeq ($(config_mak),1)

include Makefile.cfg

# fix basedir path (relative -> absolute)
ifneq (,$(basedir))
ifeq (,$(filter /%, $(basedir)))
override basedir:=$(CURDIR)/$(basedir)
# remove basedir from command line overrides
MAKEOVERRIDES:=$(filter-out basedir=%,$ $(MAKEOVERRIDES))
endif # (,$(filter /%, $(basedir)))
endif # (,$(basedir))

else ifneq ($(config_mak),skip)

config.mak: Makefile.defs Makefile.groups
	@echo making config...
	@echo "# this file is autogenerated by make cfg" >$@
	@$(call mapf2,cfg_save_var,saved_fixed_vars,$(@))
	@$(call mapf2,cfg_save_var2,saved_chg_vars,$(@))
	@echo "override makefile_defs:=1" >>$@
	@echo "C_DEFS:=\$$(filter-out \$$(DEFS_RM) \$$(extra_defs),\$$(C_DEFS))" \
					"\$$(extra_defs)"  >>$@
	@echo "CFLAGS:=\$$(filter-out \$$(CFLAGS_RM) \$$(CC_EXTRA_OPTS)," \
						"\$$(CFLAGS)) \$$(CC_EXTRA_OPTS)" >>$@

endif # ifeq ($(config_mak),1)

modules.lst: Makefile.groups
	@echo  saving modules list...
	@echo "# this file is autogenerated by make modules-cfg" >$@
	@echo >>$@
	@echo "# the list of sub-directories with modules" >>$@
	@echo "modules_dirs:=$(modules_dirs)" >>$@
	@echo >>$@
	@echo "# the list of module groups to compile" >>$@
	@echo "cfg_group_include=$(group_include)" >>$@
	@echo >>$@
	@echo "# the list of extra modules to compile" >>$@
	@$(call cfg_save_var2,include_modules,$@)
	@echo >>$@
	@echo "# the list of static modules" >>$@
	@$(call cfg_save_var2,static_modules,$@)
	@echo >>$@
	@echo "# the list of modules to skip from compile list" >>$@
	@$(call cfg_save_var2,skip_modules,$@)
	@echo >>$@
	@echo "# the list of modules to exclude from compile list" >>$@
	@$(call cfg_save_var3,exclude_modules,skip_modules,$@)
	@echo >>$@
	@$(foreach mods,$(modules_dirs), \
		$(call cfg_save_var2,$(mods)_all,$@))
	@$(foreach mods,$(modules_dirs), \
		$(call cfg_save_var2,$(mods)_noinc,$@))
	@$(foreach mods,$(modules_dirs), \
		$(call cfg_save_var2,$(mods),$@))
	@echo "modules_configured:=1" >>$@


.PHONY: cfg config cfg-defs
cfg-defs: config.mak

cfg config: cfg-defs modules-cfg

.PHONY: modules-cfg modules-list modules-lst
modules-cfg modules-list modules-lst:
	rm -f modules.lst
	$(MAKE) modules.lst

ifneq ($(wildcard ../.git),)
# if .git/ exists
repo_ver=$(shell  RV=`git rev-parse --verify --short=6 HEAD 2>/dev/null`;\
					[ -n "$$RV" ] && \
					test -n "`git update-index --refresh --unmerged >/dev/null\
							; git diff-index --name-only HEAD 2>/dev/null | \
								grep -v Makefile`" &&\
						RV="$$RV"-dirty; echo "$$RV")
repo_hash=$(subst -dirty,,$(repo_ver))
repo_state=$(subst %-dirty,dirty,$(findstring -dirty,$(repo_ver)))
autover_h_dep=../.git $(filter-out $(auto_gen), $(sources)) core/cfg.y core/cfg.lex Makefile
else
# else if .git/ does not exist
repo_ver=
repo_hash="unknown"
repo_state=
autover_h_dep=
endif


core/autover.h: $(autover_h_dep)
	@echo  "generating core/autover.h ..."
	@echo "/* this file is autogenerated by make core/autover.h" >$@
	@echo " * DO NOT EDIT IT" >>$@
	@echo " */" >>$@
	@echo "" >>$@
	@echo "#define REPO_VER \"$(repo_ver)\"" >>$@
	@echo "#define REPO_HASH \"$(repo_hash)\"" >>$@
	@echo "#define REPO_STATE \"$(repo_state)\"" >>$@

.PHONY: all
all: $(NAME) every-module

.PHONY: print-modules
print-modules:
	@echo The following modules were chosen to be included: \
		$(include_modules) ; \
	echo ---------------------------------------------------------- ; \
	echo The following modules will be excluded: $(exclude_modules) ; \

=== utils/kamcmd/Makefile ===
#
#

COREPATH=../../src/
include $(COREPATH)/Makefile.defs
include $(COREPATH)/Makefile.targets

auto_gen=
RELEASE=1.5
UTIL_SRC_NAME=kamcmd
ifeq ($(FLAVOUR),ser)
	NAME?=sercmd
else
	NAME?=kamcmd
endif

readline_localpath=$(LOCALBASE)/include/readline/readline.h
readline_locations= /usr/include/readline/readline.h \
					$(readline_localpath)

ifeq ($(CROSS_COMPILE),)
	BUILDER = $(shell which pkg-config)
ifneq ($(BUILDER),)
	PKGREADLINE = $(shell $(BUILDER) --exists readline > /dev/null 2>&1 ; echo $$? )
ifneq ($(PKGREADLINE),0)
	BUILDER =
endif
endif
endif


use_readline ?=
ifneq (,$(MAKECMDGOALS))
ifeq (,$(filter-out $(nodep_targets),$(MAKECMDGOALS)))
#set it to empty, we don't need to detect/use it for clean, doc a.s.o
override use_readline:=
quiet=1
endif
endif #ifneq (,$(MAKECMDGOALS))


# erase common DEFS (not needed)
C_DEFS:=
DEFS:= -DNAME='"$(NAME)"' -DSRNAME='"$(MAIN_NAME)"' -DVERSION='"$(RELEASE)"' -D__OS_$(OS) \
		-DRUN_DIR='"$(run_target)"' \
		$(filter -D%HAVE -DARCH% -DOS% -D__CPU% -D__OS%, $(DEFS))

# use proper libs (we can't rely on LIBS value since we might be called
# from a module Makefile)
#LIBS:=$(filter-out -lfl  -ldl -lpthread -lssl -lcrypto, $(LIBS))

ifeq ($(OS), linux)
	LIBS:= -lresolv
endif
ifeq ($(OS), solaris)
	LIBS:= -lresolv -L$(LOCALBASE)/lib -lxnet -lnsl
endif
ifeq ($(OS), freebsd)
	LIBS:=
endif
ifeq  ($(OS), dragonfly)
	LIBS:= -L$(LOCALBASE)/lib
endif
ifeq ($(OS), openbsd)
	LIBS:=
endif
ifeq ($(OS), netbsd)
	LIBS:=
endif
ifeq ($(OS), darwin)
readline_locations= /opt/local/include/readline/readline.h \
					/usr/include/readline/readline.h \
					$(readline_localpath)
	LIBS:= -lresolv
endif
ifneq (,$(findstring cygwin, $(OS)))
	LIBS:= -lresolv
endif

# detect libreadline
ifneq ($(BUILDER),)
	DEFS += $(shell $(BUILDER) --cflags readline)
	DEFS+=-DUSE_READLINE
	LIBS += $(shell $(BUILDER) --libs readline)
	use_readline := 1
else
ifeq ($(use_readline),)
readline_path := $(shell  \
						for r in $(readline_locations) ""; do \
							if [ -r "$$r" ] ; then echo $$r; exit; fi;  \
						done;\
					)
ifneq ($(readline_path),)
use_readline := 1
endif
endif

ifeq ($(use_readline),1)

ifneq (,$(findstring opt, $(readline_path)))
	DEFS+=-DUSE_READLINE -I /opt/local/include
	LIBS+=-L/opt/local/lib -lreadline -lncurses
else

ifeq ($(readline_path),$(readline_localpath))
	DEFS+=-I$(LOCALBASE)/include
	LIBS+=-L$(LOCALBASE)/lib
endif

	DEFS+=-DUSE_READLINE
	LIBS+=-lreadline -lncurses
endif

endif  # ifeq ($(use_readline),1)

endif  # ifneq ($(BUILDER),)


include $(COREPATH)/Makefile.utils

ifeq (,$(quiet))
ifeq ($(use_readline),1)
ifneq ($(BUILDER),)
$(info readline detected via pkg-config)
else
$(info readline detected ($(readline_path)) )
endif
$(info command completion enabled)
else
$(info "no readline include files detected, disabling readline support")
$(info "command completion disabled" )
$(info "to force readline support try 'make use_readline=1'")
endif
endif # ifeq (,$(quiet))

$(NAME).o:

.PHONY: msg
msg:
	@if [ "$(use_readline)" = "1" ]; then \
		if [ "$(BUILDER)" = "" ]; then \
			echo; echo "readline detected ($(readline_path)):"; \
		else \
			echo; echo "readline detected via pkg-config"; \
		fi; \
		echo "command completion enabled"; echo ; \
	else \
		echo ; \
		echo "no readline include files detected, disabling readline support";\
		echo "command completion disabled"; \
		echo "(to force readline support try 'make use_readline=1')";\
		echo ; \
	fi

modules:

=== doc/tutorials/rpc_list/Makefile ===

COREPATH=../../../src

#include $(COREPATH)/Makefile.defs

CFG2TXT=../../scripts/cdefs2doc/dump_rpcs.pl
CFG2DOCBOOK=../../scripts/cdefs2doc/dump_rpcs.pl

# output directory for generated txt files
txt_output_dir=.
# output directory for generated docbook xml files
docbook_output_dir=docbook

# list of files containing rpc defs in the following format:
# <filename>:<cfg_grp_name>
# can be easily updated by adding the output of:
#   make diff-list   (which obeys grp_exclude and file_exclude)
# or completely regenerated by replacing files_list with the output of:
#   make gen-files-list
# NOTE: suffix duplicated modules located in modules_s with '_s' to
# avoid file naming conflicts
#
files_list= \
		$(COREPATH)/core/core_cmd.c:core \
		$(COREPATH)/modules/app_jsdt/app_jsdt_api.c:app_jsdt \
		$(COREPATH)/modules/app_lua/app_lua_mod.c:app_lua \
		$(COREPATH)/modules/app_perl/app_perl_mod.c:app_perl \
		$(COREPATH)/modules/app_sqlang/app_sqlang_api.c:app_sqlang \
		$(COREPATH)/modules/auth_ephemeral/auth_ephemeral_mod.c:auth_ephemeral \
		$(COREPATH)/modules/auth_xkeys/auth_xkeys.c:auth_xkeys \
		$(COREPATH)/modules/benchmark/benchmark.c:benchmark \
		$(COREPATH)/modules/call_obj/call_obj_mod.c:call_obj \
		$(COREPATH)/modules/carrierroute/carrierroute.c:carrierroute \
		$(COREPATH)/modules/cdp/cdp_rpc.c:cdp \
		$(COREPATH)/modules/cfg_rpc/cfg_rpc.c:cfg_rpc \
		$(COREPATH)/modules/cfgt/cfgt_int.c:cfgt \
		$(COREPATH)/modules/cfgutils/cfgutils.c:cfgutils \
		$(COREPATH)/modules/cnxcc/cnxcc_mod.c:cnxcc \
		$(COREPATH)/modules/corex/corex_rpc.c:corex \
		$(COREPATH)/modules/counters/counters.c:counters \
		$(COREPATH)/modules/cplc/cpl_loader.c:cplc \
		$(COREPATH)/modules/ctl/ctl.c:ctl \
		$(COREPATH)/modules/db_berkeley/db_berkeley.c:db_berkeley \
		$(COREPATH)/modules/db_flatstore/flat_rpc.c:db_flatstore \
		$(COREPATH)/modules/db_flatstore/km_flatstore_mod.c:db_flatstore \
		$(COREPATH)/modules/db_text/db_text.c:db_text \
		$(COREPATH)/modules/debugger/debugger_api.c:debugger \
		$(COREPATH)/modules/dialog/dialog.c:dialog \
		$(COREPATH)/modules/dialplan/dialplan.c:dialplan \
		$(COREPATH)/modules/dispatcher/dispatcher.c:dispatcher \
		$(COREPATH)/modules/dmq/dmq.c:dmq \
		$(COREPATH)/modules/domain/domain_mod.c:domain \
		$(COREPATH)/modules/drouting/drouting.c:drouting \
		$(COREPATH)/modules/htable/htable.c:htable \
		$(COREPATH)/modules/http_client/curlrpc.c:http_client \
		$(COREPATH)/modules/imc/imc.c:imc \
		$(COREPATH)/modules/ims_dialog/ims_dialog.c:ims_dialog \
		$(COREPATH)/modules/ims_registrar_scscf/reg_rpc.c:ims_registrar_scscf \
		$(COREPATH)/modules/ims_usrloc_pcscf/ul_rpc.c:ims_usrloc_pcscf \
		$(COREPATH)/modules/ims_usrloc_scscf/ul_rpc.c:ims_usrloc_scscf \
		$(COREPATH)/modules/jsonrpcs/jsonrpcs_mod.c:jsonrpcs \
		$(COREPATH)/modules/keepalive/keepalive_rpc.c:keepalive \
		$(COREPATH)/modules/kex/core_stats.c:kex \
		$(COREPATH)/modules/kex/mod_stats.c:kex \
		$(COREPATH)/modules/kex/pkg_stats.c:kex \
		$(COREPATH)/modules/lcr/lcr_rpc.c:lcr \
		$(COREPATH)/modules/malloc_test/malloc_test.c:malloc_test \
		$(COREPATH)/modules/matrix/matrix.c:matrix \
		$(COREPATH)/modules/mqueue/mqueue_mod.c:mqueue \
		$(COREPATH)/modules/msrp/msrp_cmap.c:msrp \
		$(COREPATH)/modules/mtree/mtree_mod.c:mtree \
		$(COREPATH)/modules/nathelper/nathelper.c:nathelper \
		$(COREPATH)/modules/pdb/pdb.c:pdb \
		$(COREPATH)/modules/pdt/pdt.c:pdt \
		$(COREPATH)/modules/permissions/permissions.c:permissions \
		$(COREPATH)/modules/pike/pike_rpc.c:pike \
		$(COREPATH)/modules/pipelimit/pipelimit.c:pipelimit \
		$(COREPATH)/modules/prefix_route/pr_rpc.c:prefix_route \
		$(COREPATH)/modules/presence/presence.c:presence \
		$(COREPATH)/modules/pua/pua.c:pua \
		$(COREPATH)/modules/pua_rpc/pua_rpc.c:pua_rpc \
		$(COREPATH)/modules/pv/pv.c:pv \
		$(COREPATH)/modules/ratelimit/ratelimit.c:ratelimit \
		$(COREPATH)/modules/regex/regex_mod.c:regex \
		$(COREPATH)/modules/rls/rls.c:rls \
		$(COREPATH)/modules/rtpengine/rtpengine.c:rtpengine \
		$(COREPATH)/modules/rtpproxy/rtpproxy.c:rtpproxy \
		$(COREPATH)/modules/sca/sca.c:sca \
		$(COREPATH)/modules/sctp/sctp_rpc.c:sctp \
		$(COREPATH)/modules/sipcapture/sipcapture.c:sipcapture \
		$(COREPATH)/modules/siptrace/siptrace.c:siptrace \
		$(COREPATH)/modules/sl/sl_stats.c:sl \
		$(COREPATH)/modules/statsc/statsc_mod.c:statsc \
		$(COREPATH)/modules/tls/tls_rpc.c:tls \
		$(COREPATH)/modules/tm/tm.c:tm \
		$(COREPATH)/modules/tsilo/ts_rpc.c:tsilo \
		$(COREPATH)/modules/uac/uac_reg.c:uac \
		$(COREPATH)/modules/uid_domain/domain_rpc.c:uid_domain \
		$(COREPATH)/modules/uid_gflags/uid_gflags.c:uid_gflags \
		$(COREPATH)/modules/userblacklist/userblacklist.c:userblacklist \
		$(COREPATH)/modules/usrloc/ul_rpc.c:usrloc \
		$(COREPATH)/modules/websocket/websocket.c:websocket \
		$(COREPATH)/modules/xcap_client/xcap_client.c:xcap_client \
		$(COREPATH)/modules/xhttp_pi/xhttp_pi.c:xhttp_pi


# list of excluded groups
grp_exclude=pa
# list of file prefixes to exclude (full path needed)
file_exclude=$(COREPATH)/obsolete

# special per file group overrides
# format= grp_filename=... ,where filename does not contain the extension
# e.g.:
#     grp_f_tcp_options=tcp
#     grp_f_sctp_options=sctp

# special per group group name overrides
# e.g.:
#      grp_g_maxfwd=mf

# override auto-detected group if set to 1 (else the group is used inside the
# file only if it cannot be aut-odetected)
ifeq ($(group_override),1)
override force_grp=force-
else
override force_grp=
endif

# command used for gcc (contains extra includes)
gcc=gcc
#-I$(COREPATH)/lib -I$(COREPATH) -I/usr/include/libxml2

# defines used by gcc
c_defsX=-DNAME='\"kamailio\"' -DVERSION='\"5.1.0-dev3\"' -DARCH='\"x86_64\"' \
	   -DOS='linux_' -DOS_QUOTED='\"linux\"' -DCOMPILER='\"gcc 4.9.2\"' \
	   -D__CPU_x86_64 -D__OS_linux -DSER_VER=5001000 \
	   -DCFG_DIR='\"/usr/local/etc/kamailio/\"' \
	   -DRUN_DIR='\"/run/kamailio/\"' -DPKG_MALLOC -DSHM_MEM -DSHM_MMAP \
	   -DDNS_IP_HACK -DUSE_MCAST -DUSE_TCP -DDISABLE_NAGLE -DHAVE_RESOLV_RES \
	   -DUSE_DNS_CACHE -DUSE_DNS_FAILOVER -DUSE_DST_BLOCKLIST -DUSE_NAPTR \
	   -DWITH_XAVP -DMEM_JOIN_FREE -DF_MALLOC -DQ_MALLOC -DTLSF_MALLOC \
	   -DDBG_SR_MEMORY -DUSE_TLS -DTLS_HOOKS -DUSE_CORE_STATS -DSTATISTICS \
	   -DMALLOC_STATS -DWITH_AS_SUPPORT -DUSE_SCTP -DFAST_LOCK -DADAPTIVE_WAIT \
	   -DADAPTIVE_WAIT_LOOPS=1024 -DCC_GCC_LIKE_ASM -DHAVE_GETHOSTBYNAME2 \
	   -DHAVE_UNION_SEMUN -DHAVE_SCHED_YIELD -DHAVE_MSG_NOSIGNAL \
	   -DHAVE_MSGHDR_MSG_CONTROL -DHAVE_ALLOCA_H -DHAVE_TIMEGM \
	   -DHAVE_SCHED_SETSCHEDULER -DHAVE_IP_MREQN -DHAVE_EPOLL -DHAVE_SIGIO_RT \
	   -DSIGINFO64_WORKARROUND -DUSE_FUTEX -DHAVE_SELECT

c_defs=$(subst ^^,='\",$(subst ",\"',$(subst =",^^,$(shell $(MAKE) -s -C ../../../src printcdefs))))

c_defs+= -DMOD_NAME='\"rpcgen\"'
c_defs+= -I$(COREPATH)/modules/app_sqlang/squirrel/include

# common makefile vars used in defs
LOCALBASE=/usr/local
SYSBASE=/usr

filter_files=$(filter-out $(addsuffix %,$(file_exclude)),\
				$(filter-out $(addprefix %:,$(grp_exclude)),$(1)))

#filtered files list
flist=$(call filter_files,$(files_list))

# throws an error if input is not in the format filename:grp
check_fname_grp=$(if $(filter-out 2,$(words $(subst :, ,$(1)))),\
	$(error bad format "$(1)", it should be filename:grp))

# get prereq from file:grp (get_prereq(file:grp) => file)
get_prereq=$(firstword $(subst :, ,$(1)))

# get grp from file:grp (get_grp(file:grp) => grp)
get_listed_grp=$(word 2, $(subst :, ,$(1)))

# get module interface define
get_modiface=$(word 3, $(subst :, ,$(1)))

find_modiface=$(if $(findstring modules,$(1)),$(shell $(MAKE) -s -C $(dir $(1)) printmiface),-DNONE)

# get base file name from file:grp: get_bname(file:grp)
# => basename(file) without extension (e.g. get_bname(foo/bar.c:x) => bar)
#
get_bname=$(basename $(notdir $(call get_prereq,$(1))))

#get grp from file:grp, using the overrides
get_grp=$(strip $(if $(grp_f_$(call get_bname,$(1))), \
					$(grp_f_$(call get_bname,$(1))),\
					$(if $(grp_g_$(call get_listed_grp,$(1))),\
						$(grp_g_$(call get_listed_grp,$(1))),\
						$(call get_listed_grp,$(1))) ) )

# get target from file:grp (get_target(file:grp) => rpc_grp.txt)
get_target=rpc_$(call get_grp,$(1))


# $(LF) definition (do not remove)
define LF


endef

# get all the lines containing DEFS or INCLUDES definitions from the Makefile.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_idefs=$(subst ^LF^,$(LF),$(shell sed \
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*[^\]$$/H'\
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/H'\
 -ne '$${g;s/\n/^LF^/g;p}'\
< $(1)/Makefile ))


# get all the lines from the makefile containing variable definitions.
# It will also return conditionals and try to filter out possible rules.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_vars=$(subst ^LF^,$(LF),$(shell sed -n \
 -e ': start' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]*\($$\|.*[^\]$$\)/{H;b end}' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]\+.*[\]$$/,/[^\]$$/{H;b end}' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*[^\]$$/{H;b end}' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/{H;b end}' \
 -e ': end' \
 -e '$${g;s/\n/^LF^/g;p}'\
 -e 'b' \
 -e ': eat_rule' \
 -e '$$b end' \
 -e 'n' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t]/b eat_rule' \
 -e 'b start' \
< $(1)/Makefile ))


define  mk_rules

$(call check_fname_grp, $(1))

#$$(info generating rpc_$$(call get_grp,$(1)).txt: $$(call get_prereq,$(1)))


DEFS:=
INCLUDES:=
# extract all the includes and defs from the module makefile and
# evaluate them
$$(eval $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
# override COREPATH (we know better)
COREPATH=../../../src
# save the result in a per group e_idefs_<grp_name> var
$$(eval e_idefs_$$(call get_grp,$(1)):=$$(DEFS) $$(INCLUDES))

# debugging:
#$$(info eval: $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
#$$(info e_idefs_$$(call get_grp,$(1))=$$(e_idefs_$$(call get_grp,$(1))))

$(txt_output_dir)/$$(call get_target,$(1)).txt: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2TXT) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --txt \
		--defs="$(c_defs) $$(call get_modiface,$(1)) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)

$(docbook_output_dir)/$$(call get_target,$(1)).xml: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2DOCBOOK) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --docbook \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)


clean_$$(call get_target,$(1)).txt:
	rm -f "$(txt_output_dir)/$$(call get_target,$(1)).txt"

clean_$$(call get_target,$(1)).xml:
	rm -f "$(docbook_output_dir)/$$(call get_target,$(1)).xml"

txt: $(txt_output_dir)/$$(call get_target,$(1)).txt

docbook: $(docbook_output_dir)/$$(call get_target,$(1)).xml

clean_txt: clean_$$(call get_target,$(1)).txt

clean_docbook: clean_$$(call get_target,$(1)).xml


endef

find_rpc_files_cmd= find $(COREPATH) -type f -name "*.c" \
		-exec grep "rpc_export_t[	 ][a-zA-Z0-9_]*\[\][	 ]*=" /dev/null {} \; \
		| cut -d: -f1

# shell command to generate a file:grp list from a list of files
# grp will be the modulename if the file is in a module directory or
# the file name with the extension and _cmd, cmd_ or _rpc stripped out of
# it.
# output: list of  " "filename":"grpname
gen_file_grp_cmd=\
sed -e "s!\(.*/modules[^/]*/\([^/][^/]*\)/.*\)! \1:\2!" \

=== doc/tutorials/select_list/Makefile ===

COREPATH=../../../src

#include $(COREPATH)/Makefile.defs

CFG2TXT=../../scripts/cdefs2doc/dump_selects.pl
CFG2DOCBOOK=../../scripts/cdefs2doc/dump_selects.pl

# extra generators options
# use select_core.c to resolve possible chained select
CFG2TXT_EXTRA_OPTS=--core $(COREPATH)/core/select_core.c
CFG2DOCBOOK_EXTRA_OPTS=--core $(COREPATH)/core/select_core.c

# output directory for generated txt files
txt_output_dir=.
# output directory for generated docbook xml files
docbook_output_dir=docbook

# list of files containing selects defs in the following format:
# <filename>:<sel_grp_name>
# can be easily updated by adding the output of:
#   make diff-list   (which obeys grp_exclude and file_exclude)
# or completely regenerated by replacing files_list with the output of:
#   make gen-files-list
files_list= \
	$(COREPATH)/core/select_core.c:core \
	$(COREPATH)/modules/avp/avp.c:avp \
	$(COREPATH)/modules/cnxcc/cnxcc_mod.c:cnxcc \
	$(COREPATH)/modules/db2_ops/db2_ops.c:db2_ops \
	$(COREPATH)/modules/nathelper/nathelper.c:nathelper \
	$(COREPATH)/modules/textopsx/textopsx.c:textopsx \
	$(COREPATH)/modules/timer/timer.c:timer \
	$(COREPATH)/modules/tls/tls_select.c:tls \
	$(COREPATH)/modules/tm/select.c:tm \
	$(COREPATH)/modules/xmlrpc/xmlrpc.c:xmlrpc

grp_exclude=pa iptrtpproxy
# list of file prefixes to exclude (full path needed)
file_exclude= $(COREPATH)/obsolete/

# special per file group overrides
# format= grp_filename=... ,where filename does not contain the extension
# e.g.:
#     grp_f_tcp_options=tcp
#     grp_f_sctp_options=sctp

# special per group group name overrides
# e.g.:
#      grp_g_maxfwd=mf

# override auto-detected group if set to 1 (else the group is used inside the
# file only if it cannot be aut-odetected)
ifeq ($(group_override),1)
override force_grp=force-
else
override force_grp=
endif

# command used for gcc (contains extra includes)
gcc=gcc
#-I$(COREPATH)/lib -I$(COREPATH) -I/usr/include/libxml2

# defines used by gcc
c_defs=-DNAME='\"kamailio\"' -DVERSION='\"5.1.0-dev3\"' -DARCH='\"x86_64\"' \
	   -DOS='linux_' -DOS_QUOTED='\"linux\"' -DCOMPILER='\"gcc 4.9.2\"' \
	   -D__CPU_x86_64 -D__OS_linux -DSER_VER=5001000 \
	   -DCFG_DIR='\"/usr/local/etc/kamailio/\"' \
	   -DRUN_DIR='\"/run/kamailio/\"' -DPKG_MALLOC -DSHM_MEM -DSHM_MMAP \
	   -DDNS_IP_HACK -DUSE_MCAST -DUSE_TCP -DDISABLE_NAGLE -DHAVE_RESOLV_RES \
	   -DUSE_DNS_CACHE -DUSE_DNS_FAILOVER -DUSE_DST_BLOCKLIST -DUSE_NAPTR \
	   -DWITH_XAVP -DMEM_JOIN_FREE -DF_MALLOC -DQ_MALLOC -DTLSF_MALLOC \
	   -DDBG_SR_MEMORY -DUSE_TLS -DTLS_HOOKS -DUSE_CORE_STATS -DSTATISTICS \
	   -DMALLOC_STATS -DWITH_AS_SUPPORT -DUSE_SCTP -DFAST_LOCK -DADAPTIVE_WAIT \
	   -DADAPTIVE_WAIT_LOOPS=1024 -DCC_GCC_LIKE_ASM -DHAVE_GETHOSTBYNAME2 \
	   -DHAVE_UNION_SEMUN -DHAVE_SCHED_YIELD -DHAVE_MSG_NOSIGNAL \
	   -DHAVE_MSGHDR_MSG_CONTROL -DHAVE_ALLOCA_H -DHAVE_TIMEGM \
	   -DHAVE_SCHED_SETSCHEDULER -DHAVE_IP_MREQN -DHAVE_EPOLL -DHAVE_SIGIO_RT \
	   -DSIGINFO64_WORKARROUND -DUSE_FUTEX -DHAVE_SELECT


# common makefile vars used in defs
LOCALBASE=/usr/local
SYSBASE=/usr

filter_files=$(subst .h:,.c:, $(filter-out $(addsuffix %,$(file_exclude)),\
				$(filter-out $(addprefix %:,$(grp_exclude)),$(1))) )

#filtered files list
flist=$(call filter_files,$(files_list))

# throws an error if input is not in the format filename:grp
check_fname_grp=$(if $(filter-out 2,$(words $(subst :, ,$(1)))),\
					$(error bad format "$(1)", it should be filename:grp))

# get prereq from file:grp (get_prereq(file:grp) => file)
get_prereq=$(firstword $(subst :, ,$(1)))

# get grp from file:grp (get_grp(file:grp) => grp)
get_listed_grp=$(word 2, $(subst :, ,$(1)))

# get base file name from file:grp: get_bname(file:grp)
# => basename(file) without extension (e.g. get_bname(foo/bar.c:x) => bar)
#
get_bname=$(basename $(notdir $(call get_prereq,$(1))))

#get grp from file:grp, using the overrides
get_grp=$(strip $(if $(grp_f_$(call get_bname,$(1))), \
					$(grp_f_$(call get_bname,$(1))),\
					$(if $(grp_g_$(call get_listed_grp,$(1))),\
						$(grp_g_$(call get_listed_grp,$(1))),\
						$(call get_listed_grp,$(1))) ) )

# get target from file:grp (get_target(file:grp) => select_grp)
get_target=select_$(call get_grp,$(1))


# $(LF) definition (do not remove)
define LF


endef

# get all the lines containing DEFS or INCLUDES definitions from the Makefile.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_idefs=$(subst ^LF^,$(LF),$(shell sed \
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*[^\]$$/H'\
 -ne '/^[\t ]*\(DEFS\|INCLUDES\)[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/H'\
 -ne '$${g;s/\n/^LF^/g;p}'\
< $(1)/Makefile ))


# get all the lines from the makefile containing variable definitions.
# It will also return conditionals and try to filter out possible rules.
# WARNING: does not work with all sed implementation (tested with GNU sed).
# It uses a hack to restore the LFs (LFs are removed by $(shell)): LFs are
# replaced with '^LF^' and then ^LF^ is subst'ed back to a real LF.
get_make_vars=$(subst ^LF^,$(LF),$(shell sed -n \
 -e ': start' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]*\($$\|.*[^\]$$\)/{H;b end}' \
 -e '/^\(ifeq\|ifneq\|else\|endif\)[\t ]\+.*[\]$$/,/[^\]$$/{H;b end}' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*[^\]$$/{H;b end}' \
 -e '/^[\t ]*[A-Za-z._][A-Za-z0-9._-]*[\t ]*[+:]\?=.*\\$$/,/\(^$$\)\|\([^\]$$\)/{H;b end}' \
 -e ': end' \
 -e '$${g;s/\n/^LF^/g;p}'\
 -e 'b' \
 -e ': eat_rule' \
 -e '$$b end' \
 -e 'n' \
 -e '/^[a-zA-Z._/$$][a-zA-Z0-9._()/$$ \t-]*:\([^=]\|$$\)/b eat_rule' \
 -e '/^[\t]/b eat_rule' \
 -e 'b start' \
< $(1)/Makefile ))


define  mk_rules

$(call check_fname_grp, $(1))

#$$(info generating select_$$(call get_grp,$(1)).txt: $$(call get_prereq,$(1)))


DEFS:=
INCLUDES:=
# extract all the includes and defs from the module makefile and
# evaluate them
$$(eval $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
# override COREPATH (we know better)
COREPATH=../../../src
# save the result in a per group e_idefs_<grp_name> var
$$(eval e_idefs_$$(call get_grp,$(1)):=$$(DEFS) $$(INCLUDES))

# debugging:
#$$(info eval: $$(call get_make_vars,$$(dir $$(call get_prereq,$(1)))))
#$$(info e_idefs_$$(call get_grp,$(1))=$$(e_idefs_$$(call get_grp,$(1))))

$(txt_output_dir)/$$(call get_target,$(1)).txt: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2TXT) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --txt  $(CFG2TXT_EXTRA_OPTS) \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)

$(docbook_output_dir)/$$(call get_target,$(1)).xml: \
								$$(call get_prereq,$(1)) Makefile $(CFG2TXT)
	$(CFG2DOCBOOK) --file $$< --$(force_grp)grp=$$(call get_grp,$(1)) \
		--gcc="$(gcc)" --docbook $(CFG2DOCBOOK_EXTRA_OPTS) \
		--defs="$(c_defs) $$(e_idefs_$$(call get_grp,$(1)))" \
		> "$$@" || (rm -f "$$@"; exit 1)


clean_$$(call get_target,$(1)).txt:
	rm -f "$(txt_output_dir)/$$(call get_target,$(1)).txt"

clean_$$(call get_target,$(1)).xml:
	rm -f "$(docbook_output_dir)/$$(call get_target,$(1)).xml"

txt: $(txt_output_dir)/$$(call get_target,$(1)).txt

docbook: $(docbook_output_dir)/$$(call get_target,$(1)).xml

clean_txt: clean_$$(call get_target,$(1)).txt

clean_docbook: clean_$$(call get_target,$(1)).xml


endef

find_sel_files_cmd= find $(COREPATH) -type f -name "*.[ch]" \
		-exec grep "select_row_t[	 ][a-zA-Z0-9_][a-zA-Z0-9_]*\[\][	 ]*=" \
		/dev/null {} \; \
		| cut -d: -f1

# shell command to generate a file:grp list from a list of files
# grp will be the modulename if the file is in a module directory or
# the file name with the extension and _sel, sel_, select_, _select,
# _declaration or _table stripped out of it.
# output: list of  " "filename":"grpname
gen_file_grp_cmd=\
sed -e "s!\(.*/modules[^/]*/\([^/][^/]*\)/.*\)! \1:\2!" \
    -e "s!^\([^ ].*/\([^/.]*\)[^/]*$$\)!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_select[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)select[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_declaration[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_table[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)_sel[_]*!\1:\2!" \
    -e "s!^\([^ :]*\):\(.*\)sel[_]*!\1:\2!" \

# special vars for generating the list of files or updates
found_lst=$(shell $(find_sel_files_cmd) | $(gen_file_grp_cmd))
# filtered found lst
f_found_lst=$(call filter_files,$(found_lst))
diff_lst=$(filter-out $(flist),$(f_found_lst))


get_core_files=$(filter-out $(COREPATH)/modules% $(COREPATH)/lib%,$(1))
sort_files=$(sort $(call get_core_files,$(1)))\
			$(sort $(filter-out $(call get_core_files,$(1)),$(1)))

# replace $(COREPATH) with the text "$(COREPATH)"
subst_corepath=$(patsubst $(patsubst %/,%,$(COREPATH))/%,\$$(COREPATH)/%,$(1))


# help will be the default rule (on-purpose since without having a patched
# GCC:TranslationUnit module, make all won't work)
.PHONY: help
help:
	@echo "To regenerate $(foreach f,$(flist),$(call get_target,$f).{txt,xml})"
	@echo "type: $(MAKE) all ."
	@echo "or to regenerate all the select lists by searching all"
	@echo " the source files for definitions, type: $(MAKE) autogen ."
	@echo "NOTE: you need the GCC:TranslationUnit perl module with an "
	@echo "extra patch applied (see $(CFG2TXT) --patch)."

.PHONY: txt
txt:

.PHONY: docbook
docbook:

.PHONY: clean_txt
clean_txt:

.PHONY: clean_docbook
clean_docbook:


.PHONY: all
all: txt $(docbook_output_dir)/select_list.xml

.PHONY: clean
clean: clean_txt clean_docbook
	@rm -f $(docbook_output_dir)/select_list.xml

.PHONY: proper
proper:
	@rm -f $(txt_output_dir)/select_*.txt
	@rm -f $(docbook_output_dir)/select_*.xml

repo_ver="sip-router"\
	"git-$(shell  git rev-parse --verify --short=6 HEAD 2>/dev/null)"
ifeq ($(repo_ver),git-)
repo_ver="sip-router unknown"
endif

$(docbook_output_dir)/select_list.xml: Makefile \
		$(foreach f,$(flist),$(docbook_output_dir)/$(call get_target,$f).xml)
	@echo '<?xml version="1.0" encoding="UTF-8"?>' >$@
	@echo '<!-- this file is autogenerated, do not edit! -->' >>$@
	@echo '<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN"' >>$@
	@echo '	"http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd"' >>$@
	@echo '	[ <!ENTITY % local.common.attrib' >>$@
	@echo "	 \"xmlns:xi CDATA #FIXED 'http://www.w3.org/2001/XInclude'\">]">>$@
	@echo '>' >>$@
	@echo '<book id="select_list"'\
		'xmlns:xi="http://www.w3.org/2001/XInclude">' >>$@
	@echo '	<title>Select List</title>' >>$@
	@echo '	<bookinfo>' >>$@
	@echo '   <productname class="trade">kamailio.org</productname>' >>$@
	@echo '   <authorgroup>' >>$@
	@echo '    <author>' >>$@
	@echo '      <firstname>Kamailio</firstname>' >>$@
	@echo '      <surname>Development Team</surname>' >>$@
	@echo '      <affiliation><orgname>https://www.kamailio.org</orgname></affiliation>' >>$@
	@echo '      <address>sr-dev@lists.kamailio.org</address>' >>$@
	@echo '    </author>' >>$@
	@echo '   </authorgroup>' >>$@
	@echo '   <copyright>' >>$@
	@echo '    <year>2008-2017</year>' >>$@
	@echo '    <holder>Kamailio Project</holder>' >>$@
	@echo '   </copyright>' >>$@
	@echo '	</bookinfo>' >>$@
	@echo '		<xi:include href="intro.xml"/>' >>$@
	@$(foreach f,$(flist),\
		echo '		<xi:include'\
			'href="'$(call get_target,$f).xml'"/>' \
			>>$@ ; )
	@echo '</book>' >>$@

# finds all the files containing select defs
.PHONY: find
find:
	@$(find_sel_files_cmd)

# print the list of the autogenerated files
.PHONY: print-lst
print-lst:
	@$(find_sel_files_cmd) | $(gen_file_grp_cmd)

#
.PHONY: gen-file-list
.PHONY: gen-files_list
.PHONY: gen_files_list
gen-file-list gen-files-list gen_files_list:
	@$(foreach f,$(call subst_corepath,$(call sort_files,$(f_found_lst))),\
		echo "$f \\";)

.PHONY: check-list
.PHONY: update-list
.PHONY: diff-list
check-list update-list diff-list:

=== src/modules/alias_db/Makefile ===
# User aliases
#
# 
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs

auto_gen=
NAME=alias_db.so
LIBS=
DEFS+=

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/srdb1/srdb1
include ../../Makefile.modules

=== src/modules/app_perl/Makefile ===
# perl module makefile
#
#
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs
auto_gen=kamailioxs.c
NAME=app_perl.so
LIBS=

ifeq ($(PERLLDOPTS),)
	LIBS+=`perl -MExtUtils::Embed -e ldopts`
else
	LIBS+=$(PERLLDOPTS)
endif

ifeq ($(PERLCCOPTS),)
	PERLCCOPTS=$(shell perl -MExtUtils::Embed -e ccopts)
endif
DEFS+=$(PERLCCOPTS)

SERLIBPATH=../../lib

PODFILES=kamailioxs.xs `find lib/perl -name *.pm`

ifeq ($(TYPEMAP),)
	ifeq ($(PERLLIBPATH),)
		PERLLIBPATH=`perl -MConfig -e 'print $$Config{installprivlib}'`
	endif
	TYPEMAP=$(PERLLIBPATH)/ExtUtils/typemap
endif

include ../../Makefile.modules

perl.d: kamailioxs.o
perl.o: perl.c kamailioxs.o

kamailioxs.o: CFLAGS+=-Wno-unused

kamailioxs.c: kamailioxs.xs typemap
	xsubpp -typemap $(TYPEMAP) -typemap typemap kamailioxs.xs > kamailioxs.c

.PHONY: perlpod
perlpod: doc/app_perl_pod.xml

doc/app_perl_pod.sgml: kamailioxs.xs
	cat $(PODFILES) | pod2docbook --doctype=chapter --title='Kamailio Perl API' --no-header - doc/app_perl_pod.sgml

install-perl-scripts:
	echo "installing Perl Kamailio packages ..."
	mkdir -p $(modules_prefix)/$(lib_dir)/perl
	$(INSTALL_CFG) lib/perl/*.pm $(modules_prefix)/$(lib_dir)/perl
	mkdir -p $(modules_prefix)/$(lib_dir)/perl/Kamailio
	$(INSTALL_CFG) lib/perl/Kamailio/*.pm \
		$(modules_prefix)/$(lib_dir)/perl/Kamailio
	mkdir -p $(modules_prefix)/$(lib_dir)/perl/Kamailio/LDAPUtils
	$(INSTALL_CFG) lib/perl/Kamailio/LDAPUtils/*.pm \
		$(modules_prefix)/$(lib_dir)/perl/Kamailio/LDAPUtils
	mkdir -p $(modules_prefix)/$(lib_dir)/perl/Kamailio/Utils
	$(INSTALL_CFG) lib/perl/Kamailio/Utils/*.pm \
		$(modules_prefix)/$(lib_dir)/perl/Kamailio/Utils
	mkdir -p $(modules_prefix)/$(lib_dir)/perl/Kamailio/VDB
	$(INSTALL_CFG) lib/perl/Kamailio/VDB/*.pm \
		$(modules_prefix)/$(lib_dir)/perl/Kamailio/VDB
	mkdir -p $(modules_prefix)/$(lib_dir)/perl/Kamailio/VDB/Adapter
	$(INSTALL_CFG) lib/perl/Kamailio/VDB/Adapter/*.pm \
		$(modules_prefix)/$(lib_dir)/perl/Kamailio/VDB/Adapter

install-scripts: install-perl-scripts

=== src/modules/cnxcc/Makefile ===
#
# cnxcc module makefile
#
#
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs
auto_gen=
NAME=cnxcc.so

ifeq ($(CROSS_COMPILE),)
HIREDIS_BUILDER = $(shell \
	if pkg-config --exists hiredis; then \
		echo 'pkg-config hiredis'; \
	fi)
endif

ifeq ($(HIREDIS_BUILDER),)
	HIREDISDEFS=-I$(LOCALBASE)/include
	HIREDISLIBS=-L$(LOCALBASE)/lib -lhiredis
else
	HIREDISDEFS = $(shell $(HIREDIS_BUILDER) --cflags)
	HIREDISLIBS = $(shell $(HIREDIS_BUILDER) --libs)

ifeq ($(HIREDISLIBS),-L -lhiredis)
		HIREDISDEFS = $(shell $(HIREDIS_BUILDER) --cflags) /opt/local/include
		HIREDISLIBS = -L/opt/local/lib -lhiredis
endif

endif

ifeq ($(CROSS_COMPILE),)
LEVENT_BUILDER = $(shell \
	if pkg-config --exists libevent; then \
		echo 'pkg-config libevent'; \
	fi)
endif

ifeq ($(LEVENT_BUILDER),)
	LEVENTDEFS=
	LEVENTLIBS=-L$(LOCALBASE)/lib -levent
else
	LEVENTDEFS = $(shell $(LEVENT_BUILDER) --cflags)
	LEVENTLIBS = $(shell $(LEVENT_BUILDER) --libs)
endif

DEFS+=$(HIREDISDEFS) $(LEVENTDEFS)
LIBS=$(HIREDISLIBS) $(LEVENTLIBS)

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/srdb1/srdb1
include ../../Makefile.modules

=== src/modules/dialplan/Makefile ===
#
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs
auto_gen=
NAME=dialplan.so

ifeq ($(CROSS_COMPILE),)
PCRE_BUILDER = $(shell \
	if pkg-config --exists libcre; then \
		echo 'pkg-config libpcre'; \
	else \
		which pcre-config; \
	fi)
endif

ifeq ($(PCRE_BUILDER),)
	PCREDEFS=-I$(LOCALBASE)/include
	PCRELIBS=-L$(LOCALBASE)/lib -lpcre
else
	PCREDEFS = $(shell $(PCRE_BUILDER) --cflags)
	PCRELIBS = $(shell $(PCRE_BUILDER) --libs)
endif
DEFS+=$(PCREDEFS)
LIBS=$(PCRELIBS)

DEFS+=

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/srdb1/srdb1
include ../../Makefile.modules

=== src/modules/dispatcher/Makefile ===
#
# example module makefile
#
#
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs

auto_gen=
NAME=dispatcher.so

LIBS=-lm

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/srdb1/srdb1
include ../../Makefile.modules

=== src/modules/drouting/Makefile ===
#
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs
auto_gen=
NAME=drouting.so
LIBS=

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/srdb1/srdb1

include ../../Makefile.modules

=== src/modules/ims_qos/Makefile ===
#
# ims_qos make file
#
#

include ../../Makefile.defs
auto_gen=
NAME=ims_qos.so
LIBS=

SERLIBPATH=../../lib
SER_LIBS+=$(SERLIBPATH)/ims/kamailio_ims

ifneq ($(OS),darwin)
	LIBS += -lrt
	LIBS += -lpthread
endif

include ../../Makefile.modules

=== src/modules/kazoo/Makefile ===
#
# WARNING: do not run this directly, it should be run by the main Makefile

include ../../Makefile.defs
auto_gen=
NAME=kazoo.so
JLIB=json

BUILDER = $(shell which pkg-config)
ifeq ($(BUILDER),)
	JSONC=$(shell ls $(SYSBASE)/include/lib/libjson*.so $(LOCALBASE)/lib/libjson*.so 2>/dev/null | grep json-c)
else
	JSONC=$(shell pkg-config --libs json-c 2>/dev/null | grep json-c)
endif

ifneq ($(JSONC),)
	JLIB=json-c
endif

ifeq ($(BUILDER),)
	DEFS+=-I$(LOCALBASE)/include -I$(SYSBASE)/include \
		-I$(SYSBASE)/include/$(JLIB)
	LIBS=-L$(LOCALBASE)/lib -I$(SYSBASE)/lib -lrabbitmq -l$(JLIB) -luuid -levent
else
	DEFS += $(shell $(BUILDER) --cflags $(JLIB))
	LIBS += $(shell $(BUILDER) --libs $(JLIB))
	DEFS += $(shell $(BUILDER) --cflags uuid)
	LIBS += $(shell $(BUILDER) --libs uuid)
	DEFS += $(shell $(BUILDER) --cflags librabbitmq)
	LIBS += $(shell $(BUILDER) --libs librabbitmq)
	DEFS += $(shell $(BUILDER) --cflags libevent)
	LIBS += $(shell $(BUILDER) --libs libevent)
endif

SERLIBPATH=../../lib
SER_LIBS=$(SERLIBPATH)/srdb1/srdb1

include ../../Makefile.modules

=== debian/changelog ===
kamailio (5.6.3-2) unstable; urgency=medium

  * fix install rule for extras

 -- Victor Seva <vseva@debian.org>  Tue, 31 Jan 2023 20:10:56 +0100

kamailio (5.6.3-1) unstable; urgency=medium

  * debian/rules: rework rules, try to fail properly on build
  * New upstream version 5.6.3
  * fixes for app_python3 from upstream (Closes: #1027440)

 -- Victor Seva <vseva@debian.org>  Tue, 31 Jan 2023 12:54:55 +0100

kamailio (5.6.2-1) unstable; urgency=medium

  * New upstream version 5.6.2

 -- Victor Seva <vseva@debian.org>  Tue, 25 Oct 2022 23:40:36 +0200

=== debian/control ===
Source: kamailio
Section: net
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Victor Seva <vseva@debian.org>,
Build-Depends:
 bison,
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 docbook-xml,
 dpkg-dev (>= 1.16.1.1),
 erlang-dev,
 flex,
 libcurl4-openssl-dev,
 libdb-dev (>= 4.6.19),
 libev-dev,
 libevent-dev,
 libexpat1-dev,
 libgeoip-dev (>= 1.4.5),
 libhiredis-dev (>= 0.10.0),
 libjansson-dev,
 libjson-c-dev,
 libldap2-dev,
 liblua5.1-0-dev,
 libmaxminddb-dev,
 libmemcached-dev,
 libmnl-dev,
 libmongoc-dev,
 libmono-2.0-dev [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 ppc64 ppc64el s390x],
 libmosquitto-dev,
 libnats-dev,
 libncurses5-dev,
 libpcre3-dev,
 libperl-dev,
 libphonenumber-dev (>= 7),
 libpq-dev,
 librabbitmq-dev,
 libradcli-dev,
 libreadline-dev,
 libsasl2-dev,
 libsctp-dev [linux-any],
 libsecsipid-dev [amd64 arm64 armel armhf hurd-i386 i386 powerpc ppc64 ppc64el riscv64 s390x],
 libsnmp-dev,
 libsqlite3-dev,
 libssl-dev,
 libsystemd-dev,
 libwebsockets-dev,
 libunistring-dev,
 libxml2-dev,
 openssl,
 pkg-config,
 python3,
 python3-dev,
 ruby-dev,
 unixodbc-dev,
 uuid-dev,
 xsltproc,
 zlib1g-dev,
Standards-Version: 4.6.0.1
Homepage: http://www.kamailio.org/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/kamailio.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/kamailio/
Rules-Requires-Root: no

Package: kamailio
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 lsb-base,
 python3,
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 kamailio-carrierroute-modules,
Suggests:
 kamailio-berkeley-modules,
 kamailio-cpl-modules,
 kamailio-ldap-modules,
 kamailio-lua-modules,
 kamailio-mono-modules,
 kamailio-mysql-modules,
 kamailio-perl-modules,
 kamailio-postgres-modules,
 kamailio-presence-modules,
 kamailio-python3-modules,
 kamailio-radius-modules,
 kamailio-redis-modules,
 kamailio-snmpstats-modules,
 kamailio-tls-modules,
 kamailio-unixodbc-modules,
 kamailio-xml-modules,
 kamailio-xmpp-modules,
 stun-server | turn-server,
Provides:
 sip-router,
Description: very fast, dynamic and configurable SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, kamailio can handle thousands requests
 per second even on low-budget hardware. It can be configured to act
 as a SIP proxy, application server, session border controller,
 or call load balancer to handle a set of media servers.
 .
 A C Shell like scripting language provides full control over the server's
 behaviour. It's easy to integrate Kamailio with 3rd party API's and
 applications using HTTP, AMQP, database drivers, LDAP, Radius and many other
 solutions. In addition there is support for scripting using Lua, Python, Perl,
 Java and a set of other languages using Mono.
 .
 Kamailio's modular architecture allows only required functionality to be
 loaded. There are over 100 modules available: WebSockets for WebRTC,
 authentication, multiple databases - both traditional SQL databases as well as
 no-SQL, message bus systems like Rabbit MQ, instant messaging, a presence
 agent, integration with REST-ful APIs using HTTP and JSON or XML, radius
 authentication, record routing, an SMS gateway, a XMPP/jabber gateway, a
 transaction and dialog module, OSP module, statistics support,
 registrar and user location services, SNMP, SIMPLE Presence and much more.
 .
 This package contains the main Kamailio binary along with the principal
 modules and support binaries.

Package: kamailio-geoip-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: geoip module for the Kamailio SIP Server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the geoip module, an extension enabling
 usage of the GeoIP API within the Kamailio configuration file.

Package: kamailio-geoip2-modules
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: geoip2 module for the Kamailio SIP Server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the geoip2 module, an extension enabling
 real-time queries against the Max Mind GeoIP2 database within the Kamailio
 configuration file.

Package: kamailio-sqlite-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 sqlite3,
Description: SQLite database connectivity module for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the SQLite database driver for Kamailio.

Package: kamailio-json-modules
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Json parser and Json-RPC modules for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a JSON parser for use in the Kamailio
 configuration file and the JSON-RPC client over netstrings.

Package: kamailio-memcached-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 kamailio-memcached-module,
Description: interface to the memcached server, for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the memcached module, an interface to the memcached
 server, a high-performance, distributed memory object caching system.

Package: kamailio-lua-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: app_lua module for Kamailio Lua support
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_lua module, an extension allowing to
 execute embedded Lua applications within the configuration file as
 well as writing the entire configuration file in Lua.

Package: kamailio-mono-modules
Architecture: amd64 armel i386 mipsel powerpc powerpcspe ppc64 s390x
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: app_mono module for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_mono module, an extension allowing to
 execute embedded Mono applications within the Kamailio SIP routing script.

Package: kamailio-python3-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: app_python3 module for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_python3 module, an extension allowing to
 execute embedded Python applications within the Kamailio SIP routing script.

Package: kamailio-ruby-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: app_ruby module for Kamailio Ruby support
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_ruby module, an extension allowing to
 execute embedded Ruby applications within the Kamailio SIP routing script.

Package: kamailio-redis-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Redis database connectivity module for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the Redis NOSQL database driver for Kamailio.

Package: kamailio-mysql-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 default-mysql-client | virtual-mysql-client,
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: MySQL database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the MySQL database driver for Kamailio.

Package: kamailio-postgres-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 postgresql-client,
 ${misc:Depends},
 ${shlibs:Depends},
Description: PostgreSQL database connectivity module for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the PostgreSQL database driver for Kamailio.

Package: kamailio-cpl-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: CPL module (CPL interpreter engine) for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a CPL (Call Processing Language) interpreter for
 Kamailio, turning Kamailio into a CPL server (storage and interpreter).

Package: kamailio-radius-modules
Architecture: any
Multi-Arch: same
Breaks:
 kamailio (<<5.1),
Replaces:
 kamailio (<<5.1),
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: RADIUS modules for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a set of RADIUS modules for Kamailio, for
 authentication, peering, group membership and messages URIs checking against a
 RADIUS server.

Package: kamailio-unixodbc-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: unixODBC database connectivity module for the Kamailio SIP server
 Kamailio is a very fast and flexible SIP (RFC3261)
 server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the unixODBC database driver for Kamailio.

Package: kamailio-presence-modules
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 kamailio (= ${binary:Version}),
 ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# Enable parallel builds.
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

# Modules not in the "main" kamailio package:
EXCLUDED_MODULES =

# Extra modules to skip, because they are not compilable now:
# - regardless if they go to the main kamailio package or to some module
#   package, they will be excluded from compile and install of all.
EXTRA_EXCLUDED_MODULES += bdb
EXTRA_EXCLUDED_MODULES += dbtext
EXTRA_EXCLUDED_MODULES += dnssec
EXTRA_EXCLUDED_MODULES += iptrtpproxy
EXTRA_EXCLUDED_MODULES += java
EXTRA_EXCLUDED_MODULES += mi_xmlrpc
EXTRA_EXCLUDED_MODULES += oracle
EXTRA_EXCLUDED_MODULES += pa
EXTRA_EXCLUDED_MODULES += purple

# Module groups that are packaged in seperate packages (with the name
# kamailio-$(group_name)-modules).
# Note: the order is important (should be in dependency order, the one
# on which other depend first)
PACKAGE_GROUPS += mysql
PACKAGE_GROUPS += postgres
PACKAGE_GROUPS += berkeley
PACKAGE_GROUPS += unixodbc
PACKAGE_GROUPS += radius
PACKAGE_GROUPS += presence
PACKAGE_GROUPS += ldap
PACKAGE_GROUPS += xml
PACKAGE_GROUPS += perl
PACKAGE_GROUPS += utils
PACKAGE_GROUPS += lua
PACKAGE_GROUPS += memcached
PACKAGE_GROUPS += carrierroute
PACKAGE_GROUPS += snmpstats
PACKAGE_GROUPS += xmpp
PACKAGE_GROUPS += cpl
PACKAGE_GROUPS += redis
PACKAGE_GROUPS += geoip
PACKAGE_GROUPS += geoip2
PACKAGE_GROUPS += sqlite
PACKAGE_GROUPS += ruby
PACKAGE_GROUPS += ims
PACKAGE_GROUPS += sctp
PACKAGE_GROUPS += tls
PACKAGE_GROUPS += outbound
PACKAGE_GROUPS += websocket
PACKAGE_GROUPS += autheph
PACKAGE_GROUPS += cnxcc
PACKAGE_GROUPS += erlang
PACKAGE_GROUPS += systemd
PACKAGE_GROUPS += phonenum
PACKAGE_GROUPS += mongodb
PACKAGE_GROUPS += rabbitmq
PACKAGE_GROUPS += python3
PACKAGE_GROUPS += mqtt
PACKAGE_GROUPS += lwsc
PACKAGE_GROUPS += nats

# Module groups to be packaged onto kamailio-extra-modules.
EXTRA_GROUPS += ev
EXTRA_GROUPS += gzcompress
EXTRA_GROUPS += jansson
EXTRA_GROUPS += uuid

# Mono not on all arches
ifneq ("$(wildcard /usr/share/mono/mono-archs.make)","")
PACKAGE_GROUPS += mono
else
EXCLUDED_MODULES += mono
endif

# libsecsipid not on all arches
ifneq ("$(wildcard /usr/share/doc/libsecsipid-dev/copyright)","")
PACKAGE_GROUPS += secsipid
else
EXCLUDED_MODULES += secsipid
endif

# FTBFS on kfreebsd
LINUX_MODULES += json
LINUX_MODULES += kazoo
ifeq ($(DEB_HOST_ARCH_OS),linux)
PACKAGE_GROUPS += $(LINUX_MODULES)
else
EXCLUDED_MODULES += $(LINUX_MODULES)
endif

# select radius lib
ifeq ($(shell [ -f /usr/include/radcli/radcli.h ] && echo 1 || echo 0),1)
export RADCLI = 1
else
export FREERADIUS = 1
endif

# FTBFS on powerpcspe because of AltiVec assumption #729635.
ifeq ($(DEB_HOST_ARCH),powerpcspe)
export NOALTIVEC = 1
endif

D = $(CURDIR)/debian/$(DEB_SOURCE)

# Name of libdir in the path for libraries (e.g., the multiarch triplet).
export LIBDIR ?= lib/$(DEB_HOST_MULTIARCH)

# Directories with possible duplicate libraries (that should be deleted
# from current module* packages).
DUP_LIBS_DIRS = $(D)/usr/$(LIBDIR)/kamailio \
                $(D)-db-modules/usr/$(LIBDIR)/kamailio

# CFLAGS + CPPFLAGS -> CC_EXTRA_OPTS
CC_EXTRA_OPTS := $(shell dpkg-buildflags --get CPPFLAGS)
CC_EXTRA_OPTS += $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
# LDFLAGS -> LD_EXTRA_OPTS
LD_EXTRA_OPTS := $(shell dpkg-buildflags --get LDFLAGS)

# https://wiki.debian.org/ReproducibleBuilds/
CC_EXTRA_OPTS += -DVERSION_NODATE

BUILD_MODULES   := $(addprefix build_,   $(PACKAGE_GROUPS) $(EXTRA_GROUPS))
INSTALL_MODULES := $(addprefix install_, $(PACKAGE_GROUPS))
INSTALL_EXTRA   := $(addprefix install_, $(EXTRA_GROUPS))

.PHONY: $(BUILD_MODULES) $(INSTALL_MODULES) $(INSTALL_EXTRA)
test_build_all-stamp: configure-stamp
	$(MAKE) all quiet=verbose
	touch test_build_all-stamp

$(BUILD_MODULES): test_build_all-stamp
	$(MAKE) every-module group_include="k$(subst build_,,$@)" quiet=verbose

test_install_all-stamp: test_build_all-stamp
	$(MAKE) install quiet=verbose LIBDIR=$(LIBDIR) group_include="kstandard"
	touch test_install_all-stamp

$(INSTALL_MODULES): test_install_all-stamp
	$(MAKE) install-modules-all \
	  quiet=verbose \
	  LIBDIR=$(LIBDIR) \
	  BASEDIR=$(D)-$(subst install_,,$@)-modules \
	  cfg_prefix=$(D)-$(subst install_,,$@)-modules \
	  doc-dir=share/doc/$(DEB_SOURCE)-$(subst install_,,$@)-modules \
	  group_include="k$(subst install_,,$@)"
	# Eliminate duplicate libs.
	for d in $(DUP_LIBS_DIRS); do \
	  test "$$d" != "$(D)-$${module}-modules/usr/$(LIBDIR)/kamailio" && \
	  for r in `find $$d -name 'lib*' | xargs`; do \
	    echo "removing $(subst install_,,$@) lib `basename $$r` present also in $$d"; \
	    rm -f $(D)-$(subst install_,,$@)-modules/usr/$(LIBDIR)/kamailio/`basename "$$r"`; \
	  done ; \
	done
	# clean empty dirs
	find $(D)-$(subst install_,,$@)-modules -depth -empty -type d -exec rmdir {} \;

$(INSTALL_EXTRA): test_install_all-stamp
	$(MAKE) install-modules-all \
	  quiet=verbose \
	  LIBDIR=$(LIBDIR) \
	  BASEDIR=$(D)-extra-modules \
	  cfg_prefix=$(D)-extra-modules \
	  doc-dir=share/doc/$(DEB_SOURCE)-extra-modules \
	  group_include="k$(subst install_,,$@)"
	# Eliminate duplicate extra libs.
	for d in $(DUP_LIBS_DIRS); do \
	  test "$$d" != "$(D)-extra-modules/usr/$(LIBDIR)/kamailio" && \
	  for r in `find $$d -name 'lib*' | xargs`; do \
	    echo "removing extra lib `basename $$r` present also in $$d"; \
	    rm -f $(D)-extra-modules/usr/$(LIBDIR)/kamailio/`basename "$$r"`; \
	  done ; \
	done
	# clean empty dirs
	find $(D)-extra-modules -depth -empty -type d -exec rmdir {} \;

%:
	dh $@

override_dh_auto_configure: configure-stamp
configure-stamp:
	$(MAKE) cfg \
	  quiet=verbose \
	  prefix=/usr \
	  cfg_prefix=$(D) \
	  cfg_target=/etc/kamailio/ \
	  FLAVOUR=kamailio \
	  BASEDIR=$(D) \
	  CC_EXTRA_OPTS="$(CC_EXTRA_OPTS)" \
	  LD_EXTRA_OPTS="$(LD_EXTRA_OPTS)" \
	  skip_modules="$(EXCLUDED_MODULES) $(EXTRA_EXCLUDED_MODULES)" \
	  group_include="kstandard"
	touch configure-stamp

override_dh_auto_build: $(BUILD_MODULES)

override_dh_auto_clean:
	if [ -r autover.h -a ! -r debian/autover.h ]; then cp -a autover.h debian/; fi
	dh_auto_clean -- maintainer-clean
	if [ -r debian/autover.h -a ! -r autover.h ]; then mv debian/autover.h .; fi
	rm -f configure-stamp test_build_all-stamp test_install_all-stamp

override_dh_auto_install: $(INSTALL_MODULES) $(INSTALL_EXTRA)
	# Move binaries of kamailio-berkeley-modules to kamailio-berkeley-bin.
	mkdir -p $(D)-berkeley-bin/usr/
	mv $(D)-berkeley-modules/usr/sbin \
	   $(D)-berkeley-bin/usr/
	# remove if empty
	-rm -r $(D)/usr/share/man/man7/

override_dh_installexamples:
	dh_installexamples -Xobsoleted -Xsr

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installdocs:
	dh_installdocs -A doc/misc/AUTHORS
